//+------------------------------------------------------------------+
//|                                                          PPOtest.mq4 |
//|                                       Copyright  2007 Tom Balfe |
//|                                                                  |
//| Percentage Price Oscillator                                      |
//| This is a momentum indicator.                                    |
//| Signal line is EMA of PPO.                                       |
//|                                                                  |
//| Follows formula: (FastEMA-SlowEMA)/SlowEMA                       |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007 Tom Balfe"
#property link      "redcarsarasota@yahoo.com"
//----
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_minimum 0
#property indicator_maximum 100
//----
#property indicator_color1 SkyBlue
#property indicator_color2 Red
#property indicator_color3 Black//?? none??
#property indicator_color4 Black//?? none?

#property indicator_width1 2
#property indicator_width2 1
#property indicator_style2 2
//---- user changeable stuff
extern int FastEMA=12;
extern int SlowEMA=26;
extern int SignalEMA=9;
extern int RSIPeriodPPO=14;
extern int RSIPeriodSignal=14;


//---- 4 buffers
double     RSIPPOBuffer[];
double     RSISignalBuffer[];

double     PPOBuffer[];
double     SignalBuffer[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
    SetIndexStyle(2,DRAW_NONE);
   SetIndexStyle(3,DRAW_NONE);
   
   
   SetIndexDrawBegin(1,SignalEMA);//??
   IndicatorDigits(Digits+1);//??
   SetIndexBuffer(0,RSIPPOBuffer);
   SetIndexBuffer(1,RSISignalBuffer);
   
   
   SetIndexBuffer(2,PPOBuffer);
   SetIndexBuffer(3,SignalBuffer);
//----
   IndicatorShortName("PPO ("+FastEMA+","+SlowEMA+","+SignalEMA+")");
   SetIndexLabel(0,"RSIPPO");
   SetIndexLabel(1,"RSISignal");
   
   SetIndexLabel(2,"PPO");
   SetIndexLabel(3,"Signal");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- (FastEMA-SlowEMA)/SlowEMA
//---- PPO counted in the 1st buffer
   for(int i=0; i<limit; i++)
      PPOBuffer[i]=(iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i))/
      iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);
       RSIPPOBuffer[i] = iRSIOnArray(PPOBuffer,0,RSIPeriodPPO,i); i--; 
      
//---- signal line counted in the 2nd buffer
   for(i=0; i<limit; i++)
      SignalBuffer[i]=iMAOnArray(PPOBuffer,Bars,SignalEMA,0,MODE_EMA,i);
       RSISignalBuffer[i] = iRSIOnArray(SignalBuffer,0,RSIPeriodSignal,i); i--; 
      
      
   return(0);
  }
//+------------------------------------------------------------------+